/* Amplitude modulation block and sine wave patterns*/
int modulatedWave [] = {
 0x0000,0x0C8B,0x18F8,0x2528,0x30FB,0x3C56,0x471C,0x5133
,0x5A82,0x62F2,0x6A6D,0x70E2,0x7641,0x7A7D,0x7D8A,0x7F62
,0x7FFF,0x7F62,0x7D8A,0x7A7D,0x7641,0x70E2,0x6A6D,0x62F2
,0x5A82,0x5133,0x471C,0x3C56,0x30FB,0x2528,0x18F8,0x0C8B
,0x0000,0xF374,0xE707,0xDAD7,0xCF04,0xC3A9,0xB8E3,0xAECC
,0xA57D,0x9D0D,0x9592,0x8F1D,0x89BE,0x8582,0x8275,0x809D
,0x8000,0x809D,0x8275,0x8582,0x89BE,0x8F1D,0x9592,0x9D0D
,0xA57D,0xAECC,0xB8E3,0xC3A9,0xCF04,0xDAD7,0xE707,0xF374
};
#define SINE_SIZE (sizeof(modulatedWave)/sizeof(modulatedWave[0]))

int sineWave [] = {
 0x0000,0x0C8B,0x18F8,0x2528,0x30FB,0x3C56,0x471C,0x5133
,0x5A82,0x62F2,0x6A6D,0x70E2,0x7641,0x7A7D,0x7D8A,0x7F62
,0x7FFF,0x7F62,0x7D8A,0x7A7D,0x7641,0x70E2,0x6A6D,0x62F2
,0x5A82,0x5133,0x471C,0x3C56,0x30FB,0x2528,0x18F8,0x0C8B
,0x0000,0xF374,0xE707,0xDAD7,0xCF04,0xC3A9,0xB8E3,0xAECC
,0xA57D,0x9D0D,0x9592,0x8F1D,0x89BE,0x8582,0x8275,0x809D
,0x8000,0x809D,0x8275,0x8582,0x89BE,0x8F1D,0x9592,0x9D0D
,0xA57D,0xAECC,0xB8E3,0xC3A9,0xCF04,0xDAD7,0xE707,0xF374
};

int speed = 0x0004;     /* USED TO CONTROL WAIT LOOP */

struct sine {
   int inValue;
   int outValue;
   int factor;
   };

struct sine sineValue;

int main (void);
int modulate (struct sine *value);
int multiply (struct sine *value);
int delay_update (int count);

int main (void)
{
   int i, j;

   while (1){
      for (i = SINE_SIZE-1; i >= 0; i--){
         sineValue.factor = i;
         modulate (&sineValue);
         }
      for (i = 0; i < SINE_SIZE; i++){
         sineValue.factor = -i;
         modulate (&sineValue);
         }
      for (i = SINE_SIZE-1; i >= 0; i--){
         sineValue.factor = -i;
         modulate (&sineValue);
         }
      for (i = 0; i < SINE_SIZE; i++){
         sineValue.factor = i;
         modulate (&sineValue);
         }
      }
}

int modulate (struct sine *value)
{
   int j;

   for (j = 0; j < SINE_SIZE; j ++){
      value->inValue = sineWave[j];
      multiply (value);
      modulatedWave[j] = value->outValue;
      delay_update (speed);
      }
   return 0;
}

int multiply (struct sine *value)
{
   int   a;

   a = value->inValue / SINE_SIZE;
   value->outValue = a * value->factor;
   return 0;
}

int delay_update (int count)
{
   int value;
   int i;

   value = 0;
   for (i = 0; i < count; i++)
      value += count;
   return value;
}

